const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const button_links = sequelize.define(
    'button_links',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      label: {
        type: DataTypes.TEXT,
      },

      url: {
        type: DataTypes.TEXT,
      },

      icon: {
        type: DataTypes.TEXT,
      },

      enabled: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      order_index: {
        type: DataTypes.INTEGER,
      },

      click_count: {
        type: DataTypes.INTEGER,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  button_links.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.button_links.hasMany(db.analytics_events, {
      as: 'analytics_events_link',
      foreignKey: {
        name: 'linkId',
      },
      constraints: false,
    });

    //end loop

    db.button_links.belongsTo(db.blocks, {
      as: 'block',
      foreignKey: {
        name: 'blockId',
      },
      constraints: false,
    });

    db.button_links.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.button_links.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.button_links.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return button_links;
};
